/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest{}

// AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest struct for AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest
type AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest struct {
	Service *string                       `json:"service,omitempty"`
	Data    *GoogleAdsStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest instantiates a new AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest() *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest{}
	var service string = "google_ads_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest{}
	var service string = "google_ads_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) GetData() GoogleAdsStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret GoogleAdsStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) GetDataOk() (*GoogleAdsStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given GoogleAdsStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) SetData(v GoogleAdsStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest struct {
	value *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) Get() *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) Set(val *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest(val *AppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) *NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleAdsStaticGoogleAdsStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
